# Luxsci.Marketing3Api

All URIs are relative to *https://rest.luxsci.com/perl/api/v2*, unless a hostname is provided ([see README](../README.md#documentation-for-api-endpoints))

Method | HTTP request | Description
------------- | ------------- | -------------
[**addCampaign**](Marketing3Api.md#addCampaign) | **POST** /user/{username}/marketing/campaigns | 
[**addContact**](Marketing3Api.md#addContact) | **POST** /user/{username}/marketing/contact | 
[**addContacts**](Marketing3Api.md#addContacts) | **POST** /user/{username}/marketing/contacts | 
[**addList**](Marketing3Api.md#addList) | **POST** /user/{username}/marketing/list | 
[**addListGroup**](Marketing3Api.md#addListGroup) | **PUT** /user/{username}/marketing/list_group/{list_group_id} | 
[**deleteCampaign**](Marketing3Api.md#deleteCampaign) | **DELETE** /user/{username}/marketing/campaign/{campaign_id} | 
[**deleteContact**](Marketing3Api.md#deleteContact) | **DELETE** /user/{username}/marketing/contact/{contact_id} | 
[**deleteList**](Marketing3Api.md#deleteList) | **DELETE** /user/{username}/marketing/list/{list_id} | 
[**deleteListGroup**](Marketing3Api.md#deleteListGroup) | **DELETE** /user/{username}/marketing/list_group/{list_group_id} | 
[**getCampaign**](Marketing3Api.md#getCampaign) | **GET** /user/{username}/marketing/campaign/{campaign_id} | 
[**getCampaigns**](Marketing3Api.md#getCampaigns) | **GET** /user/{username}/marketing/campaigns | 
[**getContact**](Marketing3Api.md#getContact) | **GET** /user/{username}/marketing/contact/{contact_id} | 
[**getContacts**](Marketing3Api.md#getContacts) | **GET** /user/{username}/marketing/contacts | 
[**getList**](Marketing3Api.md#getList) | **GET** /user/{username}/marketing/list/{list_id} | 
[**getListGroups**](Marketing3Api.md#getListGroups) | **GET** /user/{username}/marketing/list_groups | 
[**getLists**](Marketing3Api.md#getLists) | **GET** /user/{username}/marketing/lists | 
[**getReportBounced**](Marketing3Api.md#getReportBounced) | **GET** /user/{username}/marketing/report/bounced | 
[**getReportClicked**](Marketing3Api.md#getReportClicked) | **GET** /user/{username}/marketing/report/clicked | 
[**getReportComplaints**](Marketing3Api.md#getReportComplaints) | **GET** /user/{username}/marketing/report/complaints | 
[**getReportLogs**](Marketing3Api.md#getReportLogs) | **GET** /user/{username}/marketing/report/logs | 
[**getReportOpened**](Marketing3Api.md#getReportOpened) | **GET** /user/{username}/marketing/report/opened | 
[**getReportUnsubscribed**](Marketing3Api.md#getReportUnsubscribed) | **GET** /user/{username}/marketing/report/unsubscribed | 
[**getReportUrls**](Marketing3Api.md#getReportUrls) | **GET** /user/{username}/marketing/report/urls | 
[**updateCampaign**](Marketing3Api.md#updateCampaign) | **PUT** /user/{username}/marketing/campaign/{campaign_id} | 
[**updateContact**](Marketing3Api.md#updateContact) | **PUT** /user/{username}/marketing/contact/{contact_id} | 
[**updateList**](Marketing3Api.md#updateList) | **PUT** /user/{username}/marketing/list/{list_id} | 
[**updateListGroup**](Marketing3Api.md#updateListGroup) | **POST** /user/{username}/marketing/list_group/{list_group_id} | 

<a name="addCampaign"></a>
# **addCampaign**
> InlineResponse20042 addCampaign(username, opts)



Add New Campaign. {{ACL: User Marketing - Campaign Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'body': new Luxsci.SM3CampaignPOSTBody(), // SM3CampaignPOSTBody | 
};
apiInstance.addCampaign(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **body** | [**SM3CampaignPOSTBody**](SM3CampaignPOSTBody.md)|  | [optional] 

### Return type

[**InlineResponse20042**](InlineResponse20042.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="addContact"></a>
# **addContact**
> InlineResponse20040 addContact(username, opts)



Add New Contact List. {{ACL: User Marketing - Contact Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'body': null, // {String: String} | 
};
apiInstance.addContact(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **body** | [**{String: String}**](Object.md)|  | [optional] 

### Return type

[**InlineResponse20040**](InlineResponse20040.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="addContacts"></a>
# **addContacts**
> InlineResponse20039 addContacts(body, username, opts)



Add New Contacts in Bulk. {{ACL: User Marketing - Contact Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let body = null; // Object | An array of JSON objects containing Contact properties.
let username = "username_example"; // String | 
let opts = { 
};
apiInstance.addContacts(body, username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**Object**](Object.md)| An array of JSON objects containing Contact properties. | 
 **username** | **String**|  | 

### Return type

[**InlineResponse20039**](InlineResponse20039.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="addList"></a>
# **addList**
> InlineResponse20035 addList(body, username, opts)



Add New Contact List. {{ACL: User Marketing - List Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let body = new Luxsci.SM3ListBody(); // SM3ListBody | A JSON object containing List properties.
let username = "username_example"; // String | 
let opts = { 
};
apiInstance.addList(body, username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SM3ListBody**](SM3ListBody.md)| A JSON object containing List properties. | 
 **username** | **String**|  | 

### Return type

[**InlineResponse20035**](InlineResponse20035.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="addListGroup"></a>
# **addListGroup**
> InlineResponse20037 addListGroup(username, opts)



Create a new email list group. {{ACL: Marketing - List Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'body': new Luxsci.ListGroupListGroupIdBody(), // ListGroupListGroupIdBody | 
};
apiInstance.addListGroup(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **body** | [**ListGroupListGroupIdBody**](ListGroupListGroupIdBody.md)|  | [optional] 

### Return type

[**InlineResponse20037**](InlineResponse20037.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="deleteCampaign"></a>
# **deleteCampaign**
> InlineResponse201 deleteCampaign(username, campaignId, opts)



Delete a campaign.  Note that deleing a campaign will also delete logs and statistics and other data related to that campaign. {{ACL: Marketing - Campaign Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let campaignId = "campaignId_example"; // String | Campaign Id.
let opts = { 
};
apiInstance.deleteCampaign(username, campaignId, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignId** | **String**| Campaign Id. | 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="deleteContact"></a>
# **deleteContact**
> InlineResponse201 deleteContact(username, contactId, opts)



Delete a contact. {{ACL: Marketing - Contact Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let contactId = "contactId_example"; // String | List Id.
let opts = { 
};
apiInstance.deleteContact(username, contactId, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **contactId** | **String**| List Id. | 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="deleteList"></a>
# **deleteList**
> InlineResponse201 deleteList(username, id, opts)



Note: deleting a contact list will delete any contacts in that list. {{ACL: Marketing - List Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let id = "id_example"; // String | List Id.
let opts = { 
  'contactsOnly': 56, // Number | If passed and true, this call will delete all contacts in the list, but the list itself will not be deleted.
};
apiInstance.deleteList(username, id, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **id** | **String**| List Id. | 
 **contactsOnly** | **Number**| If passed and true, this call will delete all contacts in the list, but the list itself will not be deleted. | [optional] 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="deleteListGroup"></a>
# **deleteListGroup**
> InlineResponse2003 deleteListGroup(username, listGroupId, opts)



Delete a specific email list group.  {{ACL: Marketing - List Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let listGroupId = "listGroupId_example"; // String | Unique Id for this list group.
let opts = { 
};
apiInstance.deleteListGroup(username, listGroupId, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **listGroupId** | **String**| Unique Id for this list group. | 

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getCampaign"></a>
# **getCampaign**
> InlineResponse20043 getCampaign(username, campaignId, opts)



Return details about the specified Campaign. {{ACL: User: Marketing - Campaign Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let campaignId = 56; // Number | Campaign id for the specific campaign you want details for.
let opts = { 
};
apiInstance.getCampaign(username, campaignId, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignId** | **Number**| Campaign id for the specific campaign you want details for. | 

### Return type

[**InlineResponse20043**](InlineResponse20043.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getCampaigns"></a>
# **getCampaigns**
> InlineResponse20034 getCampaigns(username, opts)



Return summary data of all visible Campaigns. The Campaign creation date is used with date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaigns) {{ACL: User: Marketing - Reporting}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'userId': 56, // Number | Select campaigns owned by the given user ID.
  'status': "status_example", // String | Campaign Status Enum.
  'useDate': "created", // String | This report uses the Campaign created date by default for all date-related filtering and sorting.  Set this parameter to \"modified\" to instead used the modified date.  Set it to \"send_at\" to use the date/time that the Campaign is scheduled to be sent.  Any other value passed in this parameter will cause the \"created\" date to be used.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example" // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
};
apiInstance.getCampaigns(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **userId** | **Number**| Select campaigns owned by the given user ID. | [optional] 
 **status** | **String**| Campaign Status Enum. | [optional] 
 **useDate** | **String**| This report uses the Campaign created date by default for all date-related filtering and sorting.  Set this parameter to \&quot;modified\&quot; to instead used the modified date.  Set it to \&quot;send_at\&quot; to use the date/time that the Campaign is scheduled to be sent.  Any other value passed in this parameter will cause the \&quot;created\&quot; date to be used. | [optional] [default to created]
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getContact"></a>
# **getContact**
> InlineResponse20041 getContact(username, contactId, opts)



Return the specified Contact. {{ACL: Marketing - Contact Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let contactId = 56; // Number | Contact id for the specific contact list you want details for.
let opts = { 
  'details': 56, // Number | If details=1 (default) return custom fields.
};
apiInstance.getContact(username, contactId, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **contactId** | **Number**| Contact id for the specific contact list you want details for. | 
 **details** | **Number**| If details&#x3D;1 (default) return custom fields. | [optional] 

### Return type

[**InlineResponse20041**](InlineResponse20041.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getContacts"></a>
# **getContacts**
> InlineResponse20034 getContacts(username, opts)



Return all Contacts in the specified List.  If no list is specified, then all contacts across all lists will be returned.  The contact creation date is used with date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_contacts) {{ACL: Marketing - Reports}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'useDate': "created", // String | This report uses the created date by default for all date-related filtering and sorting.  Set this parameter to \"modified\" to instead used the modified date. Any other value passed in this parameter will cause the \"created\" date to be used.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example", // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'listId': 56, // Number | List id to get all contacts in a specific List. If this is omitted, then all contacts across all Lists will be returned.
  'segmentId': 56, // Number | Segment id to get all contacts in a specific Segment.  Note that you can specify both a segment_id and a list_id to get contacts in a specific List that are also in a specific Segment.
  'details': 56, // Number | Whe nset to true (1), data for all custom fields will also be included in the response.
};
apiInstance.getContacts(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **useDate** | **String**| This report uses the created date by default for all date-related filtering and sorting.  Set this parameter to \&quot;modified\&quot; to instead used the modified date. Any other value passed in this parameter will cause the \&quot;created\&quot; date to be used. | [optional] [default to created]
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **listId** | **Number**| List id to get all contacts in a specific List. If this is omitted, then all contacts across all Lists will be returned. | [optional] 
 **segmentId** | **Number**| Segment id to get all contacts in a specific Segment.  Note that you can specify both a segment_id and a list_id to get contacts in a specific List that are also in a specific Segment. | [optional] 
 **details** | **Number**| Whe nset to true (1), data for all custom fields will also be included in the response. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getList"></a>
# **getList**
> InlineResponse20036 getList(username, listId, opts)



Return details about the specified Contact List. {{ACL: Marketing - List Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let listId = 56; // Number | List id for the specific contact list you want details for.
let opts = { 
};
apiInstance.getList(username, listId, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **listId** | **Number**| List id for the specific contact list you want details for. | 

### Return type

[**InlineResponse20036**](InlineResponse20036.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getListGroups"></a>
# **getListGroups**
> InlineResponse20038 getListGroups(username, opts)



This function returns a list of all lists groups accessible to you.  {{ACL: Marketing - List Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
};
apiInstance.getListGroups(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 

### Return type

[**InlineResponse20038**](InlineResponse20038.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getLists"></a>
# **getLists**
> InlineResponse20034 getLists(username, opts)



Return all Contact Lists. The list creation date is used with date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_lists) {{ACL: Marketing - Reports}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'listGroupId': 56, // Number | Group id getting all lists in a specific group
  'useDate': "created", // String | This report uses the created date by default for all date-related filtering and sorting.  Set this parameter to \"modified\" to instead used the modified date. Any other value passed in this parameter will cause the \"created\" date to be used.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example" // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
};
apiInstance.getLists(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **listGroupId** | **Number**| Group id getting all lists in a specific group | [optional] 
 **useDate** | **String**| This report uses the created date by default for all date-related filtering and sorting.  Set this parameter to \&quot;modified\&quot; to instead used the modified date. Any other value passed in this parameter will cause the \&quot;created\&quot; date to be used. | [optional] [default to created]
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getReportBounced"></a>
# **getReportBounced**
> InlineResponse20034 getReportBounced(username, opts)



Return bounce data/email delivery failure data of all selected Campaigns. Uses delivery_status_updated as the date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_bounces) {{ACL: User: Marketing - Reporting}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'campaignIds': "campaignIds_example", // String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  'detail': "detail_example", // String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  'email': "email_example", // String | Filter results by matching any Contact email address containing the given string.
  'domain': "domain_example", // String | Filter results by matching any Contact email address in a domain name containing the given string.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example" // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
};
apiInstance.getReportBounced(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignIds** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getReportClicked"></a>
# **getReportClicked**
> InlineResponse20034 getReportClicked(username, opts)



Return click data of all selected Campaigns. The click date is used with date matching criteria unless the \&quot;use_date\&quot; parameter is set to \&quot;sent\&quot;. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_clicked) {{ACL: User: Marketing - Reporting}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'campaignIds': "campaignIds_example", // String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  'useDate': "useDate_example", // String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  'detail': "detail_example", // String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  'email': "email_example", // String | Filter results by matching any Contact email address containing the given string.
  'domain': "domain_example", // String | Filter results by matching any Contact email address in a domain name containing the given string.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example" // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
};
apiInstance.getReportClicked(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignIds** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **useDate** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getReportComplaints"></a>
# **getReportComplaints**
> InlineResponse20034 getReportComplaints(username, opts)



Return spam complaint data from all selected Campaigns. The message delivery status updated date is used by default for date selections, unless \&quot;use_date\&quot; is set to \&quot;sent\&quot;. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_complaints) {{ACL: User: Marketing - Reporting}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'campaignIds': "campaignIds_example", // String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  'useDate': "useDate_example", // String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  'detail': "detail_example", // String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  'email': "email_example", // String | Filter results by matching any Contact email address containing the given string.
  'domain': "domain_example", // String | Filter results by matching any Contact email address in a domain name containing the given string.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example" // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
};
apiInstance.getReportComplaints(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignIds** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **useDate** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getReportLogs"></a>
# **getReportLogs**
> InlineResponse20034 getReportLogs(username, opts)



Return sending log data of all selected Campaigns.  This includes all metadata for each recipient, including the delivery status, open status, click staus, etc.  The delivery status last updated date is used with date matching criteria. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_logs) {{ACL: User: Marketing - Reporting}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'campaignIds': "campaignIds_example", // String | Select campaigns as string of comma-separated campaign ids. If omitted, all campaigns are selected.
  'detail': "detail_example", // String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  'email': "email_example", // String | Filter results by matching any Contact email address containing the given string.
  'domain': "domain_example", // String | Filter results by matching any Contact email address in a domain name containing the given string.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example" // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
};
apiInstance.getReportLogs(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignIds** | **String**| Select campaigns as string of comma-separated campaign ids. If omitted, all campaigns are selected. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getReportOpened"></a>
# **getReportOpened**
> InlineResponse20034 getReportOpened(username, opts)



Return open event data of all selected Campaigns. The open date is used with date matching criteria, unless the \&quot;use_date\&quot; parameter is set to \&quot;sent\&quot;. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_opened) {{ACL: User: Marketing - Reporting}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'campaignIds': "campaignIds_example", // String | Select campaigns as string of comma-separated campaign ids. If omitted, all campaigns are selected.
  'useDate': "useDate_example", // String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  'detail': "detail_example", // String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  'email': "email_example", // String | Filter results by matching any Contact email address containing the given string.
  'domain': "domain_example", // String | Filter results by matching any Contact email address in a domain name containing the given string.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example" // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
};
apiInstance.getReportOpened(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignIds** | **String**| Select campaigns as string of comma-separated campaign ids. If omitted, all campaigns are selected. | [optional] 
 **useDate** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getReportUnsubscribed"></a>
# **getReportUnsubscribed**
> InlineResponse20034 getReportUnsubscribed(username, opts)



Return unsubscribe data of all selected Campaigns. The unsubscribe date is used with date matching criteria, unless the \&quot;use_date\&quot; parameter is set to \&quot;sent\&quot;. See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_unsubscribed) {{ACL: User: Marketing - Reporting}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'campaignIds': "campaignIds_example", // String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  'useDate': "useDate_example", // String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  'detail': "detail_example", // String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  'email': "email_example", // String | Filter results by matching any Contact email address containing the given string.
  'domain': "domain_example", // String | Filter results by matching any Contact email address in a domain name containing the given string.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example" // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
};
apiInstance.getReportUnsubscribed(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignIds** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **useDate** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getReportUrls"></a>
# **getReportUrls**
> InlineResponse20034 getReportUrls(username, opts)



Return clicked-on urls of all selected Campaigns. The click date is used with date matching criteria unless the \&quot;use_date\&quot; parameter is set to \&quot;sent\&quot;.  See also [API Reporting Basics](/rest-api/reporting.html) and [report header columns in the response.](/rest-api/report-responses.html#sm3_campaign_report_urls) {{ACL: User: Marketing - Reporting}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let opts = { 
  'campaignIds': "campaignIds_example", // String | Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected.
  'useDate': "useDate_example", // String | If set to \"sent\", use the date the message was sent, instead of the date of the open event, for date selections.
  'detail': "detail_example", // String | Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0.
  'email': "email_example", // String | Filter results by matching any Contact email address containing the given string.
  'domain': "domain_example", // String | Filter results by matching any Contact email address in a domain name containing the given string.
  'afterDate': "afterDate_example", // String | DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT
  'beforeDate': "beforeDate_example", // String | DATETIME. Return only matches dated before this date time.
  'firstRow': 0, // Number | (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row=50000 to get rows 50000 to 99,999.
  'fromDate': "fromDate_example", // String | DATETIME. Return only matches dated on or after this date time.
  'matches': 50000, // Number | (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets.
  'throughDate': "throughDate_example", // String | DATETIME. Return only matches dated before or on this date time.
  'destination': "destination_example", // String | For reporting requests.  Specifying a destination makes the report \"asynchronous.\"  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \"job number\" and the filename that will be uploaded.  The supported value of \"destination\" is currently only \"sftp\" for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \"destination\" is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance.
  'destinationDirectory': "destinationDirectory_example", // String | For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \"chdir\" command.
  'destinationHostname': "destinationHostname_example", // String | For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded.
  'destinationPassword': "destinationPassword_example", // String | For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded.
  'destinationUsername': "destinationUsername_example" // String | For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded.
};
apiInstance.getReportUrls(username, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignIds** | **String**| Select campaigns as string of comma-separated campaign ids.  If omitted, all campaigns are selected. | [optional] 
 **useDate** | **String**| If set to \&quot;sent\&quot;, use the date the message was sent, instead of the date of the open event, for date selections. | [optional] 
 **detail** | **String**| Boolean.  If 1, include the values of all Contact Custom Fields in the report. Default is 0. | [optional] 
 **email** | **String**| Filter results by matching any Contact email address containing the given string. | [optional] 
 **domain** | **String**| Filter results by matching any Contact email address in a domain name containing the given string. | [optional] 
 **afterDate** | **String**| DATETIME. Return only matches dated after this date time. Format “YYYY-MM-DD HH:MM:SS” in GMT | [optional] 
 **beforeDate** | **String**| DATETIME. Return only matches dated before this date time. | [optional] 
 **firstRow** | **Number**| (Default value 0). All of the matches are sorted and numbered starting from 0. E.g. if you have 100,000 matches, these are rows 0 through 99,999. If you specify a first_row, then the returned matches will be those rows starting from that row. E.g. without a specification (or if you specify 0), you might get rows 0 through 49,999. In your next request you might specify first_row&#x3D;50000 to get rows 50000 to 99,999. | [optional] [default to 0]
 **fromDate** | **String**| DATETIME. Return only matches dated on or after this date time. | [optional] 
 **matches** | **Number**| (Default value 50000). You can set matches to any value from 0 to 50000. This sets the maximum number of matches that will be returned in response to your request. Note that if the response size starts to exceed 50MB, then the response can still include fewer than your “matches” number, to keep the response size reasonable. If you specify “0” here, then no matches will be returned; however, you will still get the information on the number of matches that there were.  For asynchronous reports (ones where a destination is specified), the matches parameter is not limited to 50000, but it still defaults to 50000 if not specified. If you expect a larger number of rows, then you must explicitly approve the maximum size of the result set by setting matches appropriately.  This helps prevent accidental queries that produce very larger result sets. | [optional] [default to 50000]
 **throughDate** | **String**| DATETIME. Return only matches dated before or on this date time. | [optional] 
 **destination** | **String**| For reporting requests.  Specifying a destination makes the report \&quot;asynchronous.\&quot;  This means that a background job will be created to run the report and upload the final CSV file to the requested destination.  The API request to start the report will return immediately with a background \&quot;job number\&quot; and the filename that will be uploaded.  The supported value of \&quot;destination\&quot; is currently only \&quot;sftp\&quot; for a Secure FTP upload over SSH (as opposed to ftps, which would be a Secure FTP upload over SSL).  When \&quot;destination\&quot; is specified, additional destination parameters are also required.  Note that for SFTP uploads, there is a 15-minute upload timeout -- uploads that take longer (e.g., due to slow SFTP servers) will be aborted.  WARNING: Multiple concurrent large asynchronous report requests will impact your database performance: reports will take longer to generate and your LuxSci services will experience degraded/slower performance. | [optional] 
 **destinationDirectory** | **String**| For asynchronous reporting requests.  This optional parameter will be the subdirectory to change to on the SFTP server before uploading the report CSV file.  Technically speaking, this will be the argument provided to the SFTP \&quot;chdir\&quot; command. | [optional] 
 **destinationHostname** | **String**| For asynchronous reporting requests.  This will be the hostname of the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationPassword** | **String**| For asynchronous reporting requests.  This will be the password to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 
 **destinationUsername** | **String**| For asynchronous reporting requests.  This will be the username to be used for the login to the SFTP server to which the report CSV file should be uploaded. | [optional] 

### Return type

[**InlineResponse20034**](InlineResponse20034.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateCampaign"></a>
# **updateCampaign**
> InlineResponse201 updateCampaign(username, campaignId, opts)



Update information for existing Campaign. {{ACL: Marketing - Campaign Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let campaignId = "campaignId_example"; // String | Campaign Id.
let opts = { 
  'body': new Luxsci.SM3CampaignPUTBody(), // SM3CampaignPUTBody | 
};
apiInstance.updateCampaign(username, campaignId, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **campaignId** | **String**| Campaign Id. | 
 **body** | [**SM3CampaignPUTBody**](SM3CampaignPUTBody.md)|  | [optional] 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateContact"></a>
# **updateContact**
> InlineResponse201 updateContact(body, username, contactId, opts)



Update information for existing Contact such as E-mail address or custom fields attached to the parent List. {{ACL: Marketing - Contact Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let body = {
  "email" : "support@luxsci.com",
  "customer_id_custom_field" : 999,
  "list_id" : "28"
}; // {String: String} | A JSON object containing Contact properties.
let username = "username_example"; // String | 
let contactId = "contactId_example"; // String | Contact Id.
let opts = { 
};
apiInstance.updateContact(body, username, contactId, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**{String: String}**](Object.md)| A JSON object containing Contact properties. | 
 **username** | **String**|  | 
 **contactId** | **String**| Contact Id. | 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateList"></a>
# **updateList**
> InlineResponse201 updateList(body, username, id, opts)



Update information for existing Contact Lists such as From Name or From Address. This can also be used to assign custom fields to specific lists, but the custom field must exist in the platform in advance. Return contact information and other general metadata for the user. {{ACL: Marketing - List Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let body = new Luxsci.SM3ListBody(); // SM3ListBody | A JSON object containing List properties.
let username = "username_example"; // String | 
let id = "id_example"; // String | List Id.
let opts = { 
};
apiInstance.updateList(body, username, id, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**SM3ListBody**](SM3ListBody.md)| A JSON object containing List properties. | 
 **username** | **String**|  | 
 **id** | **String**| List Id. | 

### Return type

[**InlineResponse201**](InlineResponse201.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateListGroup"></a>
# **updateListGroup**
> InlineResponse2003 updateListGroup(username, listGroupId, opts)



Update the List Group name. {{ACL: Marketing - List Management}}

### Example
```javascript
import {Luxsci} from 'luxsci';

const secret_key = "SECRET_KEY";
const token = "TOKEN";

const luxsciClient = await Luxsci.Client({
  publicToken:token,
  privateToken:secret_key
});
let apiInstance = luxsciClient.Marketing3Api

let username = "username_example"; // String | 
let listGroupId = "listGroupId_example"; // String | Unique Id for this list group.
let opts = { 
  'body': new Luxsci.ListGroupListGroupIdBody1(), // ListGroupListGroupIdBody1 | 
};
apiInstance.updateListGroup(username, listGroupId, opts).then((data) => {
  console.log('API called successfully. Returned data: ' + data);
}, (error) => {
  console.error(error);
});

```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **username** | **String**|  | 
 **listGroupId** | **String**| Unique Id for this list group. | 
 **body** | [**ListGroupListGroupIdBody1**](ListGroupListGroupIdBody1.md)|  | [optional] 

### Return type

[**InlineResponse2003**](InlineResponse2003.md)

### Authorization

Authorization handled with secret key and public token provided

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

